package org.ks1.j3dbvh.bvh;

import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class BVHBehavior extends Behavior {
    String bName;
    TransformGroup tg;
    Transform3D t;
    ChannelData channels[];
    int frameCount;
    double frameTime;
    int elapsedTime;
    int count;
    double xLoc[];
    double yLoc[];
    double zLoc[];
    double xRot[];
    double yRot[];
    double zRot[];
    boolean stopFlag = false;

    public BVHBehavior(String bName,TransformGroup tg,Transform3D t,ChannelData cd[]) {
        this.bName = bName;
        this.tg = tg;
        this.t = t;
        this.channels = cd;
    }

    public void initialize() {
        if (elapsedTime==0) //<-- なんでこれが必要なのか
            return;         //<-- わからない
        WakeupOnElapsedTime w = new WakeupOnElapsedTime(elapsedTime);
        wakeupOn(w);
    }
    public void processStimulus(Enumeration criteria) {
        if (stopFlag == false) {
            if ((xRot!=null)&&(yRot!=null)&&(zRot!=null)) {
                t.rotZ(zRot[count]);
                Transform3D tt = new Transform3D();
                tt.rotX(xRot[count]);
                t.mul(tt);
                tt.rotY(yRot[count]);
                t.mul(tt);
            }
            if ((xLoc!=null)&&(yLoc!=null)&&(zLoc!=null)) {
              t.setTranslation(new Vector3d(xLoc[count],yLoc[count],zLoc[count]));
            }
            tg.setTransform(t);
            count++;
        }
        if (count >= frameCount) {
            count = 0;
        }
        WakeupOnElapsedTime w = new WakeupOnElapsedTime(elapsedTime);
        wakeupOn(w);
    }

    public void start() {
        count = 0;
        stopFlag = false;
    }

    public void stop() {
        stopFlag = true;
    }

    public void setFrameCount(int c) {
        frameCount = c;
    }

    public void setFrameTime(double d) {
        frameTime = d;
        elapsedTime = (int)(1000.0*d);
    }

    public void calc() {
        if (frameCount != channels[0].size()) {
            System.out.println("BVHBehavior.calc().");
            System.out.println("????.");
        }
        for (int i=0;i<channels.length;i++) {
            String s = channels[i].getChannelName();
            if (s.equals("Xposition")) {
                xLoc = new double[frameCount];
                for (int j=0;j<frameCount;j++) {
                    xLoc[j] = ((Double)channels[i].get(j)).doubleValue();
                    xLoc[j] = xLoc[j];
                }
            } else if (s.equals("Yposition")) {
                yLoc = new double[frameCount];
                for (int j=0;j<frameCount;j++) {
                    yLoc[j] = ((Double)channels[i].get(j)).doubleValue();
                    yLoc[j] = yLoc[j];
                }
            } else if (s.equals("Zposition")) {
                zLoc = new double[frameCount];
                for (int j=0;j<frameCount;j++) {
                    zLoc[j] = ((Double)channels[i].get(j)).doubleValue();
                    zLoc[j] = zLoc[j];
                }
            } else if (s.equals("Xrotation")) {
                xRot = new double[frameCount];
                for (int j=0;j<frameCount;j++) {
                    xRot[j] = ((Double)channels[i].get(j)).doubleValue();
                    xRot[j] = xRot[j]/360.0*2.0*Math.PI;
                }
            } else if (s.equals("Yrotation")) {
                yRot = new double[frameCount];
                for (int j=0;j<frameCount;j++) {
                    yRot[j] = ((Double)channels[i].get(j)).doubleValue();
                    yRot[j] = yRot[j]/360.0*2.0*Math.PI;
                }
            } else if (s.equals("Zrotation")) {
                zRot = new double[frameCount];
                for (int j=0;j<frameCount;j++) {
                    zRot[j] = ((Double)channels[i].get(j)).doubleValue();
                    zRot[j] = zRot[j]/360.0*2.0*Math.PI;
                }
            }
        }
        channels = null;
    }
}
